import javax.swing.*;
import javax.swing.table.*;

public class PlayerInfoModel extends AbstractTableModel{
    public int getColumnCount() { return 11; }
    public int getRowCount()    { return 9;}
    public Object getValueAt(int row, int col) { 
	switch(row){
	case 0: return new Double(FormationEditor.instance.aF.player[col].homePosition.getX());
	case 1: return new Double(FormationEditor.instance.aF.player[col].homePosition.getY());
	case 2: return new Double(FormationEditor.instance.aF.player[col].initPosition.getX());
	case 3: return new Double(FormationEditor.instance.aF.player[col].initPosition.getY());
	case 4: return new Double(FormationEditor.instance.aF.player[col].attrX); 
	case 5: return new Double(FormationEditor.instance.aF.player[col].attrY);
	case 6: return new Double(FormationEditor.instance.aF.player[col].maxX);
	case 7: return new Double(FormationEditor.instance.aF.player[col].minX);
	case 8: return new JCheckBox("", (FormationEditor.instance.aF.player[col].behindBall));
	default: 
	    return null;
	}
    }
    public String getColumnName(int col){
	return "Player "+ (col+1);
    }
    public void setValueAt(Object n, int row, int col) { 	 
	if (row < 0 || row > 7) return;
	double v = 0;
	try{
	    v = (Math.rint(Double.parseDouble((String)n) * 100))/100; 
	}catch(Exception e){
	    return;
	}
	switch(row){
	case 0: 
	    if (FormationEditor.isInvalidVector2D(new Vector2D(v, FormationEditor.instance.aF.player[col].homePosition.getY()))) return;
	    FormationEditor.instance.aF.player[col].homePosition.setX(v);
	    break;
	case 1:
	    if (FormationEditor.isInvalidVector2D(new Vector2D(FormationEditor.instance.aF.player[col].homePosition.getX(), v))) return;
	    FormationEditor.instance.aF.player[col].homePosition.setY(v);
	    break;
	case 2: 
	    if (FormationEditor.isInvalidVector2DForInit(new Vector2D(v, FormationEditor.instance.aF.player[col].initPosition.getY()))) return;
	    FormationEditor.instance.aF.player[col].initPosition.setX(v);
	    break;
	case 3:
	    if (FormationEditor.isInvalidVector2DForInit(new Vector2D(FormationEditor.instance.aF.player[col].initPosition.getX(), v))) return;
	    FormationEditor.instance.aF.player[col].initPosition.setY(v);
	    break;
	case 4:		
	    FormationEditor.instance.aF.player[col].attrX = v; 
	    break;
	case 5:
	    FormationEditor.instance.aF.player[col].attrY = v; 
	    break;
	case 6:
	    FormationEditor.instance.aF.player[col].maxX = v; 
	    break;
	case 7:
	    FormationEditor.instance.aF.player[col].minX = v; 
	    break;
	case 8:
	    break;
	default:
	    break;
	}
	if (row > 5 && FormationEditor.instance.showLimits.getState()) FormationEditor.instance.field.repaint();		
	if (row < 4) FormationEditor.instance.field.repaint();
    }
    public boolean isCellEditable(int rowIndex, int columnIndex){
	return true;
    }
}
