import javax.swing.*;
import javax.swing.table.*;
import java.awt.*;

class RowHeaderRenderer extends JLabel implements ListCellRenderer {	
    RowHeaderRenderer(JTable table) {
	JTableHeader header = table.getTableHeader();
	setOpaque(true);
	setBorder(UIManager.getBorder("TableHeader.cellBorder"));
	setHorizontalAlignment(CENTER);
	setForeground(header.getForeground());
	setBackground(header.getBackground());
	setFont(header.getFont());
	setSize(90,table.getRowHeight());
	setPreferredSize(new Dimension(90,table.getRowHeight()));
    }
	
    public Component getListCellRendererComponent( JList list, 
						   Object value, int index, boolean isSelected, boolean cellHasFocus) {
	setText((value == null) ? "" : value.toString());
	return this;
    }
}
