import java.awt.*;
import java.awt.geom.*;
import javax.swing.*;
import java.util.LinkedList;

public class Statistics extends JFrame{
    public static final int SCALE = 2;




    LinkedList lines = new LinkedList();
    FormationEditor f;
    static Statistics instance;
    StatisticsPanel panel;
    JPanel bPanel, bPanel2;
    
    JToggleButton bBall, bOwn, bOpp; 
    JToggleButton bPlayer[] = new JToggleButton[11];
    JToggleButton bSC, bA50, bA100;

    public Statistics(){
	super();
	instance = this;
	f = FormationEditor.instance;
	setVisible(true);
	setDefaultLookAndFeelDecorated(true);
	//setResizable(false);

	panel = new StatisticsPanel();
	panel.setSize(1800, 300);
	panel.setDoubleBuffered(true);
	
	bPanel  = new JPanel();
	bPanel2 = new JPanel();
	JScrollPane jsp = new JScrollPane(panel);
	//jsp.add(panel);
	Dimension size  = new Dimension(900,200);
	Dimension size2 = new Dimension(18000,300);
	//jsp.setSize(size);
	Dimension size3  = new Dimension(900,300);
	jsp.setPreferredSize(size3);
	jsp.setMaximumSize(size3);
	setSize(size);
	bPanel.setSize(500, 100);
	bPanel.setSize(500, 100);
	bBall = new JToggleButton("Ball");
	bOwn  = new JToggleButton("Left Team");
	bOpp  = new JToggleButton("Right Team");
	bSC   = new JToggleButton("Stopped Cycles");
	bA50  = new JToggleButton("Average last 50");
	bA100 = new JToggleButton("Average last 100");
	//	bBall.addActionListener(f.mial);
	//      bOwn.addActionListener(f.mial);
	//      bOpp.addActionListener(f.mial);
	ButtonGroup jbg = new ButtonGroup();
	for (int i = 0; i < 11; i++){
	    bPlayer[i] = new JToggleButton(""+ (i+1));
	    jbg.add(bPlayer[i]);
	    bPanel2.add(bPlayer[i]);
	}
	bPanel.add(bBall);
	bPanel.add(bOwn);
	bPanel.add(bOpp);
	bPanel.add(bSC);
	bPanel.add(bA50);
	bPanel.add(bA100);
	panel.setPreferredSize(size2);
	JPanel tmp = new JPanel();
	tmp.add(bPanel2, BorderLayout.NORTH);
	tmp.add(bPanel,  BorderLayout.SOUTH);
	//getContentPane().add(panel/*jsp*/, BorderLayout.NORTH);
	getContentPane().add(jsp, BorderLayout.NORTH);
	getContentPane().add(tmp, BorderLayout.SOUTH);
	//getContentPane().add(bPanel/*jsp*/, BorderLayout.SOUTH);
	setTitle("FormationEditor - Statistics");
	pack();
	setDefaultCloseOperation(DISPOSE_ON_CLOSE);
	init();
    }

    public void dispose(){
	f.stats = null;
	super.dispose();
    }

    public void init(){
	if (f == null) f = FormationEditor.instance;
	StatisticsLine own[] = new StatisticsLine[11];
	StatisticsLine opp[] = new StatisticsLine[11];
	StatisticsLine ball  = new StatisticsLine(0,0);

	WorldModel wm = f.firstWorldModel;
	int x = 0;
	// init
	Player p;
	for (int i = 0; i < 11; i++){
	    own[i] = new StatisticsLine(0,0);
	    opp[i] = new StatisticsLine(0,0);
	}
       
	while(wm.next != null){
	    x++;
	    for (int i = 0; i < 11; i++){
		p = (Player)wm.left.getPlayerWithUNum(i+1);
		if (p != null)
		    own[i].addPoint(x, p.position.confidence, wm.cycle, wm.stoppedCycle);
		else
		    own[i].addPoint(x, 0, wm.cycle, wm.stoppedCycle);
		p = (Player)wm.right.getPlayerWithUNum(i+1);
		if (p != null)
		    opp[i].addPoint(x, p.position.confidence, wm.cycle, wm.stoppedCycle);	    
		else
		    opp[i].addPoint(x,0, wm.cycle, wm.stoppedCycle);
		
	    }
	    ball.addPoint(x, wm.ball.position.confidence, wm.cycle, wm.stoppedCycle);
	    wm = wm.next;
	}
	for (int i = 0; i < 11; i++)
	    lines.add(own[i]);
	for (int i = 0; i < 11; i++)
	    lines.add(opp[i]);
	lines.add(ball);

	Dimension d = new Dimension(x*SCALE + 50,150*SCALE);
	panel.setSize(d);
	panel.setPreferredSize(d);
    }
    
    
}
