import java.awt.*;
import javax.swing.*;

public class StatisticsPanel extends JPanel{
    Statistics s;
	
    public void paintComponent(Graphics go){
	if (s == null) s = Statistics.instance;
	Graphics2D g = (Graphics2D)go;	    
	super.paintComponent(g);
	//g.setTransform(new AffineTransform(1.0, 0.0, 0.0, -1.0, 0.0, 0.0));
	g.translate(5,5); 
	g.scale(s.SCALE,s.SCALE);

	setBackground(new Color(210,210,210));
	g.setColor(Color.GRAY);
	g.drawLine(0, 100, 20000, 100);
	g.drawLine(0,  75, 20000,  75);
	g.drawLine(0,  50, 20000,  50);
	g.drawLine(0,  25, 20000,  25);
	g.drawLine(0,   0, 20000,   0);
	g.setColor(Color.BLACK);

	int actC  = s.f.activeWorldModel.cycle;
	int actSC = s.f.activeWorldModel.stoppedCycle;
	boolean gotIt = false;

	int lastMarked = 0;
	int mx = 0;
	//int SCB = -1;
	    
	for(int i = 0; i < s.lines.size(); i++){		
	    if (i <  11 && !s.bOwn.isSelected()) continue;
	    if (i >= 11 && i <  22 && !s.bOpp.isSelected()) continue;
	    if (i == 22 && !s.bBall.isSelected()) continue;
	    if (i != 22 && !s.bPlayer[i%11].isSelected()) continue;
	    StatisticsLine line = (StatisticsLine)(s.lines.get(i));
	    for (int j = 0; j < line.points.size()-1; j++){
		StatisticsPoint p1 = (StatisticsPoint)line.points.get(j);
		StatisticsPoint p2 = (StatisticsPoint)line.points.get(j+1);
		if (!s.bSC.isSelected() && p1.sc != 0){ mx++; continue; }
		if (p1.sc != 0){
		    g.setColor(Color.LIGHT_GRAY);
		    g.fillRect(p1.x, 0, 1, 100);
		}		    
		if (!gotIt && p1.c == actC && p1.sc == actSC){
		    g.setColor(Color.RED);
		    g.drawLine(p1.x-mx,0, p1.x-mx, 100);
		    gotIt = true;
		}else
		    if (p1.c%100 == 0 && p1.c != lastMarked){
			g.setColor(Color.GRAY);
			g.drawLine(p1.x-mx,0, p1.x-mx, 115);
			g.drawString(""+p1.c, p1.x+2-mx,115);
			lastMarked = p1.c;
		    }
		if (s.bA50.isSelected()){
		    g.setColor(Color.GREEN);
		    int fr = j - 50;
		    int to = j;
		    float v1 = line.getMeanValueFromTo(fr,to);
		    float v2 = line.getMeanValueFromTo(fr+1,to+1);
		    g.drawLine(p1.x-mx, (int)(100 - (v1*100)),
			       p2.x-mx, (int)(100 - (v2*100)));
		}
		if (s.bA100.isSelected()){
		    g.setColor(Color.BLUE);
		    int fr = j - 100;
		    int to = j;
		    float v1 = line.getMeanValueFromTo(fr,to);
		    float v2 = line.getMeanValueFromTo(fr+1,to+1);
		    g.drawLine(p1.x-mx, (int)(100 - (v1*100)),
			       p2.x-mx, (int)(100 - (v2*100)));
		}
		g.setColor(Color.BLACK);
		g.drawLine(p1.x-mx,100-p1.y,
			   p2.x-mx,100-p2.y);		    
	    }
	    if (i < 11)
		System.out.println("Left Team["+ (i+1) +"], average confidence: "+ line.getMeanValue());
	    else if (i < 22)
		System.out.println("Right Team["+ (i-10) +"], average confidence: "+ line.getMeanValue());
	    else if (i == 22)
		System.out.println("Ball, average confidence: "+ line.getMeanValue());
	}
    }        
}
