import java.util.LinkedList;
import java.io.*;
import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;
import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;

public class XMLParser extends DefaultHandler{

    // public static LinkedList cycles = new LinkedList();
    public static WorldModel   lastWorldModel = null;
    public static WorldModel   actualWorldModel = null;
    public static WorldModel   firstWorldModel = null;
    public static MovingObject actualObject = null;
    public static Team         actualTeam = null;
    public static Vector2D     actualVector = null;
    public static int numCycles = 0;
    public static int unum;

    public int step = 0;

    public static XMLParser instance;

    public void start(String filename){
	//cycles = new LinkedList();
	DefaultHandler handler = new XMLParser();
	SAXParserFactory factory = SAXParserFactory.newInstance();
        try {
	    SAXParser saxParser = factory.newSAXParser();
            saxParser.parse( new File(filename), handler );
        } catch (Throwable t) {
            t.printStackTrace();
        }
	//System.out.println("First worldmodel is cycle ("+ firstWorldModel.cycle +","+ firstWorldModel.stoppedCycle +")");
    }
    
    public void print(){
	WorldModel temp = firstWorldModel;
	do{ temp.print(); temp = temp.next; }while(temp != null);
	/*
	  for (int i = 0; i < cycles.size(); i++){
	    ((WorldModel)cycles.get(i)).print();
	}
	*/
    }
    static int cTP = -1;
    public static void main(String argv[]){
	if (argv.length < 1) {
	    System.err.println("Usage: cmd filename [cycle]");	    
            System.exit(1);
        }
	if (argv.length == 2){
	    try{
		cTP = Integer.parseInt(argv[1]);
	    }catch(Exception e){ cTP = -1; }
	}
	instance = new XMLParser();
	instance.start(argv[0]);
	if (cTP == -1) instance.print();
	System.out.println("Anzahl gespeicherter Zyklen: "+ numCycles);
        System.exit(0);	
    }

    private void emit(String s){
    }

    private void nl(){
    }
    
    public void startDocument(){
    }

    public void endDocument(){
    }
    
    public void startElement(String namespaceURI,
                             String sName, // simple name (localName)
                             String qName, // qualified name
                             Attributes attrs){
	step = -1;
        String eName = sName; // element name
        if ("".equals(eName)) eName = qName; // namespaceAware = false	
	if (eName.equals("activeplayer")){
	    step = 10;
	}       
	else if (eName.equals("wm")){
	    numCycles++;
	    WorldModel temp = new WorldModel();
	    if (actualWorldModel != null){
		actualWorldModel.next = temp;
		temp.prev = actualWorldModel;
		//lastWorldModel = actualWorldModel;	       
	    }
	    actualWorldModel = temp;
	    if (firstWorldModel == null) 
		firstWorldModel = actualWorldModel;
	    actualTeam = null;
	    actualObject = null;
	    actualVector = null;
	    step = 0;
	}
	else if (eName.equals("cycle")){
	    step = 1;
	}
	else if (eName.equals("sc")){
	    step = 11;
	}
	else if (eName.equals("g")){
	    step = 12;
	}
	else if (eName.equals("pt")){
	    step = 13;
	}
	else if (eName.equals("ball")){
	    actualObject = new Ball();
	}
	else if (eName.equals("pos")){
	    actualVector = new Vector2D();
	}
	else if (eName.equals("v")){
	    actualVector = new Vector2D();
	}
	else if (eName.equals("x")){
	    step = 2;
	}
	else if (eName.equals("y")){
	    step = 3;
	}
	else if (eName.equals("c")){
	    step = 7;
	}
	else if (eName.equals("t")) {
	    actualTeam = new Team();
	}
	else if (eName.equals("name")) {
	    step = 4;
	}
	else if (eName.equals("p")){
	    actualObject = new Player();
	}
	else if (eName.equals("unum")){
	    step = 5;
	}
	else if (eName.equals("side")){
	    step = 6;
	}
	else if (eName.equals("bo"))
	    step = 8;
	else if (eName.equals("he"))
	    step = 9;
	else if (eName.equals("ox"))
	    step = 14;
    }
    
    public void endElement(String namespaceURI,
                           String sName, // simple name
                           String qName  // qualified name
                          ){
	if (qName.equals("pos")){
	    actualObject.position = actualVector;
	    actualVector = null;
	}
 	if (qName.equals("v")){
	    actualObject.velocity = actualVector;
	    actualVector = null;
	}	    
 	if (qName.equals("ball")){
	    actualWorldModel.ball = (Ball)actualObject;
	    actualObject = null;
	}
	if (qName.equals("p")){
	    actualTeam.player.add(actualObject);
	    actualObject = null;
	}
	if (qName.equals("t")){
	    if (actualWorldModel.left == null)
		actualWorldModel.left = actualTeam;
	    else 
		actualWorldModel.right = actualTeam;
	    actualTeam = null;
	}
	if (qName.equals("wm")){
	    System.out.println("Done reading worldmodel for ("+ actualWorldModel.cycle +","+ actualWorldModel.stoppedCycle +")");
	    //if (lastWorldModel != null){
	    //lastWorldModel.next = actualWorldModel;
	    //actualWorldModel.prev = lastWorldModel;	    
	    //}
	    //lastWorldModel = actualWorldModel;
	    //actualWorldModel = null;
	}
    }
    
    public int error = 1;
    public void characters(char buf[], int offset, int len){
        String s = new String(buf, offset, len);
	
	if (s.trim().equals("")) return;
	if (s.trim().equals("-")){
	    error = -1;
	    return;
	}
	if (s.trim().equals("nan")) return;
	// if (actualWorldModel.cycle == 503) System.out.println(s);
	switch (step){
	case 1:
	    try{
		actualWorldModel.cycle = Integer.parseInt(s) * error;
	    }catch(Exception e){ System.out.println("Fehler beim Einlesen des Zyklus! "+ s); };
	    break;
	case 2:
	    try{
		actualVector.x = Double.parseDouble(s) * error;
	    }catch(Exception e){ System.out.println("Fehler beim Einlesen des X-Wertes! "+ s); };
	    break;
	case 3:
	    try{
		actualVector.y = Double.parseDouble(s) * error;
	    }catch(Exception e){ System.out.println("Fehler beim Einlesen des Y-Wertes! "+ s); };
	    break;
	case 4:
	    actualTeam.name = s;
	    //System.out.println(s);
	    break;
	case 5:	
	    try{
		((Player)actualObject).unum = Integer.parseInt(s) * error;
	    }catch(Exception e){ System.out.println("Fehler beim Einlesen der UNUM! "+ s); };
	    //System.out.println(((Player)actualObject).unum);
	    break;
	case 6:       
	    try{
		actualTeam.side = s;
	    }catch(Exception e){ System.out.println("Fehler beim Einlesen der Teamseite! "+ s); };
	    break;
	case 7:
	    try{
		actualVector.confidence = ((float)Math.floor(Float.parseFloat(s) * error * 100)) / 100.0f;
	    }catch(Exception e){ System.out.println("Fehler beim Einlesen der Confidence! "+ s); };
	    break;
	case 8:
	    try{
		((Player)actualObject).bodyDir = Double.parseDouble(s) * error;
	    }catch(Exception e){ System.out.println("Fehler beim Einlesen der BodyDir! "+ s); };
	    break;
	case 9:
	    try{
		((Player)actualObject).headDir = Double.parseDouble(s) * error;
	    }catch(Exception e){ System.out.println("Fehler beim Einlesen der HeadDir! "+ s); };
	    break;
	case 10:
	    try{
		unum = Integer.parseInt(s) * error;
	    }catch(Exception e){ System.out.println("Fehler beim Einlesen der UNUM des aktiven Spielers! "+ s); };
	    break;
        case 11:
	    try{
		actualWorldModel.stoppedCycle = Integer.parseInt(s) * error;
	    }catch(Exception e){ System.out.println("Fehler beim Einlesen des stopped Zyklus! "+ s); };
	    break;
	case 12:
	    try{
		((Player)actualObject).goalie = (Integer.parseInt(s) * error == 1 ? true : false);
	    }catch(Exception e){ System.out.println("Fehler beim Einlesen des isGoalie-Wertes! "+ s); };
	    break;
	case 13:
	    try{
		((Player)actualObject).playerType = Integer.parseInt(s) * error;
	    }catch(Exception e){ System.out.println("Fehler beim Einlesen des PlayerTypes! "+ s); };
	    break;
	case 14:
	    try{
		actualWorldModel.offsideX = Float.parseFloat(s) * error;
	    }catch(Exception e){ System.out.println("Fehler beim Einlesen der Abseits-Achse! "+ s); };
	    break;
	default:
	    System.out.println("Unbekannten Wert eingelesen: "+ s);
	    break;
	}	
	error = 1;
    }
}
