/***********************************************************************
 * WorldModelLogger.hh
 * Copyright (c) 2003 Virtual Werder
 *
 * implements:
 *   class WorldModelLogger
 *
 * requires:
 *
 *
 * Created on: 20.10.2003 by harlekin
 * Maintainer: harlekin
 * Group:
 * Co-authors: 
 *
 * Changelog:
 *
 * $Id: WorldModelLogger.hh,v 1.1.1.1 2004/01/30 15:13:41 harlekin Exp $
 *
 **********************************************************************/

#ifndef WORLDMODELLOGGER_HH
#define WORLDMODELLOGGER_HH

#include "Geometry.hh"
#include "common.hh"
#include "ConfigFile.hh"
#include "Player.hh"
#include "Team.hh"
#include "Ball.hh"
#include <fstream>
#include <sstream>
#include <vector>

// forward declarations
class WorldModel;
class Myself;

class WorldModelLogger {
private:

  WorldModel *wm;
  Myself *ms;
  ofstream out;
  int uNum;
  void openFile(void);

public:
  static WorldModelLogger *wml;

  WorldModelLogger(WorldModel *wm);

  void writeLeadIn();
  void writeCurrentCycle();
  void writePlayer( Player *player );
  void writeBall( Ball *ball );
  void writeTeam(const  char* teamname, const char* teamside, Team *team );
  void writeLeadOut();
};

#endif 
