//test

#include <fstream>
#include <unistd.h>

#include "ParserIntfc.hh"

class TestParser : public ParserIntfc {
public:
  virtual void buildInit(int unum){
    cout << "ParserIntfc::buildInit("<< unum << "): called" << endl;
  }

  virtual void buildLeftSide() {
    cout << "ParserIntfc::buildLeftSide(): called" << endl;
  }
  virtual void buildRightSide() {
    cout << "ParserIntfc::buildRightSide(): called" << endl;
  }
  virtual void buildOurSide() {
    cout << "ParserIntfc::buildOurSide(): called" << endl;
  }
  virtual void buildOppSide() {
    cout << "ParserIntfc::buildOppSide(): called" << endl;
  }


  virtual void buildPlayerType( int id,
				float player_speed_max,
				float stamina_inc_max,
				float player_decay,
				float inertia_moment,
				float dash_power_rate,
				float player_size,
				float kickable_margin,
				float kick_rand,
				float extra_stamina,
				float effort_max,
				float effort_min       
    ) {
    cout << "ParserIntfc::buildPlayerType("
	 << id << ", " 
	 << player_speed_max << ", " 
	 << stamina_inc_max << ", " 
	 << player_decay << ", " 
	 << inertia_moment << ", " 
	 << dash_power_rate << ", " 
	 << player_size << ", " 
	 << kickable_margin << ", " 
	 << kick_rand << ", " 
	 << extra_stamina << ", " 
	 << effort_max << ", " 
	 << effort_min <<"): called" << endl;
  }

  virtual void buildPlayerParam(){
    cout << "ParserIntfc::buildPlayerParam(): called" << endl;
  }
  virtual void buildPlayerParam(const PlayerParam pp, const int val){
    cout << "ParserIntfc::buildPlayerParam(" << pp << "," << val << "): called" << endl;
  }
  virtual void buildPlayerParam(const PlayerParam pp, const float val){
    cout << "ParserIntfc::buildPlayerParam(" << pp << "," << val << "): called" << endl;
  }
  /*
  virtual void buildPlayerParam(const PlayerParam pp, const bool val){
    cout << "ParserIntfc::buildPlayerParam(" << pp << "," << val << "): called" << endl;
  }
  virtual void buildPlayerParam(const PlayerParam pp, const char* val){
    cout << "ParserIntfc::buildPlayerParam(" << pp << "," << val << "): called" << endl;
  }
  */
  virtual void buildPlayerParam(int player_types,
				int pt_max,
				float random_seed,
				int subs_max,
				float dash_power_rate_delta_max,
				float dash_power_rate_delta_min,
				float effort_max_delta_factor,
				float effort_min_delta_factor,
				float extra_stamina_delta_max,
				float extra_stamina_delta_min,
				float inertia_moment_delta_factor,
				float kick_rand_delta_factor,
				float kickable_margin_delta_max,
				float kickable_margin_delta_min,
				float new_dash_power_rate_delta_max,
				float new_dash_power_rate_delta_min,
				float new_stamina_inc_max_delta_factor,
				float player_decay_delta_max,
				float player_decay_delta_min,
				float player_size_delta_factor,
				float player_speed_max_delta_max,
				float player_speed_max_delta_min,
				float stamina_inc_max_delta_factor
    ) {
    cout << "ParserIntfc::buildPlayerParam("
	 << player_types << ", " 
	 << pt_max << ", "
	 << random_seed << ", "
	 << subs_max << ", "
	 << dash_power_rate_delta_max << ", "
	 << dash_power_rate_delta_min << ", "
	 << effort_max_delta_factor << ", "
	 << effort_min_delta_factor << ", "
	 << extra_stamina_delta_max << ", "
	 << extra_stamina_delta_min << ", "
	 << inertia_moment_delta_factor << ", "
	 << kick_rand_delta_factor << ", "
	 << kickable_margin_delta_max << ", "
	 << kickable_margin_delta_min << ", "
	 << new_dash_power_rate_delta_max << ", "
	 << new_dash_power_rate_delta_min << ", "
	 << new_stamina_inc_max_delta_factor << ", "
	 << player_decay_delta_max << ", "
	 << player_decay_delta_min << ", "
	 << player_size_delta_factor << ", "
	 << player_speed_max_delta_max << ", "
	 << player_speed_max_delta_min << ", "
	 << stamina_inc_max_delta_factor << ", "
	 <<"): called" << endl;
  }
  virtual void buildServerParam(){
    cout << "ParserIntfc::buildServerParam(): called" << endl;
  }
  virtual void buildServerParam(const ServerParam sp, const int val){
    cout << "ParserIntfc::buildServerParam(" << sp << "," << val << "): called" << endl;
  }
  virtual void buildServerParam(const ServerParam sp, const double val){
    cout << "ParserIntfc::buildServerParam(" << sp << "," << val << "): called" << endl;
  }
  virtual void buildServerParam(const ServerParam sp, const bool val){
    cout << "ParserIntfc::buildServerParam(" << sp << "," << val << "): called" << endl;
  }
  virtual void buildServerParam(const ServerParam sp, const char* val){
    cout << "ParserIntfc::buildServerParam(" << sp << "," << val << "): called" << endl;
  }

  virtual void buildServerParam(
    const int catch_ban_cycle,
    const int clang_advice_win,
    const int clang_define_win,
    const int clang_del_win,
    const int clang_info_win,
    const int clang_mess_delay,
    const int clang_mess_per_cycle,
    const int clang_meta_win,
    const int clang_rule_win,
    const int clang_win_size,
    const int coach_port,
    const int drop_ball_time,
    const int freeform_send_period,
    const int freeform_wait_period,
    const int game_log_compression,
    const int game_log_version,
    const int goalie_max_moves,
    const int half_time,
    const int hear_decay,
    const int hear_inc,
    const int hear_max,
    const int max_goal_kicks,
    const int olcoach_port,
    const int point_to_ban,
    const int point_to_duration,
    const int port,
    const int recv_step,
    const int say_coach_cnt_max,
    const int say_coach_msg_size,
    const int say_msg_size,
    const int send_step,
    const int send_vi_step,
    const int sense_body_step,
    const int simulator_step,
    const int slow_down_factor,
    const int start_goal_l,
    const int start_goal_r,
    const int synch_micro_sleep,
    const int synch_offset,
    const int tackle_cycles,
    const int text_log_compression,
    const char *game_log_dir,
    const char *game_log_fixed_name,
    const char *landmark_file,
    const char *log_date_format,
    const char *text_log_dir,
    const char *text_log_fixed_name,
    const bool coach,
    const bool coach_w_referee,
    const bool old_coach_hear,
    const bool wind_none,
    const float wind_random,
    const bool back_passes,
    const bool forbid_kick_off_offside,
    const bool free_kick_faults,
    const bool fullstate_l,
    const bool fullstate_r,
    const bool game_log_dated,
    const bool game_log_fixed,
    const bool game_logging,
    const bool log_times,
    const bool profile,
    const bool proper_goal_kicks,
    const bool record_messages,
    const bool send_comms,
    const bool synch_mode,
    const bool team_actuator_noise,
    const bool text_log_dated,
    const bool text_log_fixed,
    const bool text_logging,
    const bool use_offside,
    const bool verbose,
    const float audio_cut_dist,
    const float ball_accel_max,
    const float ball_decay,
    const float ball_rand,
    const float ball_size,
    const float ball_speed_max,
    const float ball_weight,
    const float catch_probability,
    const float catchable_area_l,
    const float catchable_area_w,
    const float ckick_margin,
    const float control_radius,
    const float dash_power_rate,
    const float effort_dec,
    const float effort_dec_thr,
    const float effort_inc,
    const float effort_inc_thr,
    const float effort_init,
    const float effort_min,
    const float goal_width,
    const float inertia_moment,
    const float kick_power_rate,
    const float kick_rand,
    const float kick_rand_factor_l,
    const float kick_rand_factor_r,
    const float kickable_margin,
    const float maxmoment,
    const float maxneckang,
    const float maxneckmoment,
    const float maxpower,
    const float minmoment,
    const float minneckang,
    const float minneckmoment,
    const float minpower,
    const float offside_active_area_size,
    const float offside_kick_margin,
    const float player_accel_max,
    const float player_decay,
    const float player_rand,
    const float player_size,
    const float player_speed_max,
    const float player_weight,
    const float prand_factor_l,
    const float prand_factor_r,
    const float quantize_step,
    const float quantize_step_l,
    const float recover_dec,
    const float recover_dec_thr,
    const float recover_min,
    const float slowness_on_top_for_left_team,
    const float slowness_on_top_for_right_team,
    const float stamina_inc_max,
    const float stamina_max,
    const float stopped_ball_vel,
    const float tackle_back_dist,
    const float tackle_dist,
    const float tackle_exponent,
    const float tackle_power_rate,
    const float tackle_width,
    const float visible_angle,
    const float visible_distance,
    const float wind_ang,
    const float wind_dir,
    const float wind_force,
    const float wind_rand
    ) {
    cout << "ParserIntfc::buildServerParam("
	 << catch_ban_cycle << ", "
	 << clang_advice_win << ", "
	 << clang_define_win << ", "
	 << clang_del_win << ", "
	 << clang_info_win << ", "
	 << clang_mess_delay << ", "
	 << clang_mess_per_cycle << ", "
	 << clang_meta_win << ", "
	 << clang_rule_win << ", "
	 << clang_win_size << ", "
	 << coach_port << ", "
	 << drop_ball_time << ", "
	 << freeform_send_period << ", "
	 << freeform_wait_period << ", "
	 << game_log_compression << ", "
	 << game_log_version << ", "
	 << goalie_max_moves << ", "
	 << half_time << ", "
	 << hear_decay << ", "
	 << hear_inc << ", "
	 << hear_max << ", "
	 << max_goal_kicks << ", "
	 << olcoach_port << ", "
	 << point_to_ban << ", "
	 << point_to_duration << ", "
	 << port << ", "
	 << recv_step << ", "
	 << say_coach_cnt_max << ", "
	 << say_coach_msg_size << ", "
	 << say_msg_size << ", "
	 << send_step << ", "
	 << send_vi_step << ", "
	 << sense_body_step << ", "
	 << simulator_step << ", "
	 << slow_down_factor << ", "
	 << start_goal_l << ", "
	 << start_goal_r << ", "
	 << synch_micro_sleep << ", "
	 << synch_offset << ", "
	 << tackle_cycles << ", "
	 << text_log_compression << ", "
	 << game_log_dir << ", "
	 << game_log_fixed_name << ", "
	 << landmark_file << ", "
	 << log_date_format << ", "
	 << text_log_dir << ", "
	 << text_log_fixed_name << ", "
	 << coach << ", "
	 << coach_w_referee << ", "
	 << old_coach_hear << ", "
	 << wind_none << ", "
	 << wind_random << ", "
	 << back_passes << ", "
	 << forbid_kick_off_offside << ", "
	 << free_kick_faults << ", "
	 << fullstate_l << ", "
	 << fullstate_r << ", "
	 << game_log_dated << ", "
	 << game_log_fixed << ", "
	 << game_logging << ", "
	 << log_times << ", "
	 << profile << ", "
	 << proper_goal_kicks << ", "
	 << record_messages << ", "
	 << send_comms << ", "
	 << synch_mode << ", "
	 << team_actuator_noise << ", "
	 << text_log_dated << ", "
	 << text_log_fixed << ", "
	 << text_logging << ", "
	 << use_offside << ", "
	 << verbose << ", "
	 << audio_cut_dist << ", "
	 << ball_accel_max << ", "
	 << ball_decay << ", "
	 << ball_rand << ", "
	 << ball_size << ", "
	 << ball_speed_max << ", "
	 << ball_weight << ", "
	 << catch_probability << ", "
	 << catchable_area_l << ", "
	 << catchable_area_w << ", "
	 << ckick_margin << ", "
	 << control_radius << ", "
	 << dash_power_rate << ", "
	 << effort_dec << ", "
	 << effort_dec_thr << ", "
	 << effort_inc << ", "
	 << effort_inc_thr << ", "
	 << effort_init << ", "
	 << effort_min << ", "
	 << goal_width << ", "
	 << inertia_moment << ", "
	 << kick_power_rate << ", "
	 << kick_rand << ", "
	 << kick_rand_factor_l << ", "
	 << kick_rand_factor_r << ", "
	 << kickable_margin << ", "
	 << maxmoment << ", "
	 << maxneckang << ", "
	 << maxneckmoment << ", "
	 << maxpower << ", "
	 << minmoment << ", "
	 << minneckang << ", "
	 << minneckmoment << ", "
	 << minpower << ", "
	 << offside_active_area_size << ", "
	 << offside_kick_margin << ", "
	 << player_accel_max << ", "
	 << player_decay << ", "
	 << player_rand << ", "
	 << player_size << ", "
	 << player_speed_max << ", "
	 << player_weight << ", "
	 << prand_factor_l << ", "
	 << prand_factor_r << ", "
	 << quantize_step << ", "
	 << quantize_step_l << ", "
	 << recover_dec << ", "
	 << recover_dec_thr << ", "
	 << recover_min << ", "
	 << slowness_on_top_for_left_team << ", "
	 << slowness_on_top_for_right_team << ", "
	 << stamina_inc_max << ", "
	 << stamina_max << ", "
	 << stopped_ball_vel << ", "
	 << tackle_back_dist << ", "
	 << tackle_dist << ", "
	 << tackle_exponent << ", "
	 << tackle_power_rate << ", "
	 << tackle_width << ", "
	 << visible_angle << ", "
	 << visible_distance << ", "
	 << wind_ang << ", "
	 << wind_dir << ", "
	 << wind_force << ", "
	 << wind_rand
	 <<"): called" << endl;
  }


  virtual void buildBeforeKickOffPMode() {
    cout << "ParserIntfc::buildBeforeKickOffPMode(): called" << endl;
  }
  virtual void buildTimeOverPMode() {
    cout << "ParserIntfc::buildTimeOverPMode(): called" << endl;
  }
  virtual void buildPlayOnPMode() {
    cout << "ParserIntfc::buildPlayOnPMode(): called" << endl;
  }
  virtual void buildKickOffLPMode() {
    cout << "ParserIntfc::buildKickOffLPMode(): called" << endl;
  }
  virtual void buildKickOffRPMode() {
    cout << "ParserIntfc::buildKickOffRPMode(): called" << endl;
  }
  virtual void buildKickInLPMode() {
    cout << "ParserIntfc::buildKickInLPMode(): called" << endl;
  }
  virtual void buildKickInRPMode() {
    cout << "ParserIntfc::buildKickInRPMode(): called" << endl;
  }
  virtual void buildFreeKickLPMode() {
    cout << "ParserIntfc::buildFreeKickLPMode(): called" << endl;
  }
  virtual void buildFreeKickRPMode() {
    cout << "ParserIntfc::buildFreeKickRPMode(): called" << endl;
  }
  virtual void buildCornerKickLPMode() {
    cout << "ParserIntfc::buildCornerKickLPMode(): called" << endl;
  }
  virtual void buildCornerKickRPMode() {
    cout << "ParserIntfc::buildCornerKickRPMode(): called" << endl;
  }
  virtual void buildGoalKickLPMode() {
    cout << "ParserIntfc::buildGoalKickLPMode(): called" << endl;
  }
  virtual void buildGoalKickRPMode() {
    cout << "ParserIntfc::buildGoalKickRPMode(): called" << endl;
  }
  virtual void buildGoalLPMode() {
    cout << "ParserIntfc::buildGoalLPMode(): called" << endl;
  }
  virtual void buildGoalRPMode() {
    cout << "ParserIntfc::buildGoalRPMode(): called" << endl;
  }
  virtual void buildGoalLPMode(int goals) {
    cout << "ParserIntfc::buildGoalLPMode(" << goals << "): called" << endl;
  }
  virtual void buildGoalRPMode(int goals) {
    cout << "ParserIntfc::buildGoalRPMode(" << goals << "): called" << endl;
  }
  virtual void buildDropBallPMode() {
    cout << "ParserIntfc::buildDropBallPMode(): called" << endl;
  }
  virtual void buildOffsideLPMode() {
    cout << "ParserIntfc::buildOffsideLPMode(): called" << endl;
  }
  virtual void buildOffsideRPMode() {
    cout << "ParserIntfc::buildOffsideRPMode(): called" << endl;
  }
  virtual void buildPenaltyKickLPMode() {
    cout << "ParserIntfc::buildPenaltyKickLPMode(): called" << endl;
  }
  virtual void buildPenaltyKickRPMode() {
    cout << "ParserIntfc::buildPenaltyKickRPMode(): called" << endl;
  }
  virtual void buildPausePMode() {
    cout << "ParserIntfc::buildPausePMode(): called" << endl;
  }
  virtual void buildHumanJudgePMode() {
    cout << "ParserIntfc::buildHumanJudgePMode(): called" << endl;
  }
  virtual void buildFoulLPMode() {
    cout << "ParserIntfc::buildFoulLPMode(): called" << endl;
  }
  virtual void buildFoulRPMode() {
    cout << "ParserIntfc::buildFoulRPMode(): called" << endl;
  }
  virtual void buildFoulChargeLPMode() {
    cout << "ParserIntfc::buildFoulChargeLPMode(): called" << endl;
  }
  virtual void buildFoulChargeRPMode() {
    cout << "ParserIntfc::buildFoulChargeRPMode(): called" << endl;
  }
  virtual void buildFoulPushLPMode() {
    cout << "ParserIntfc::buildFoulPushLPMode(): called" << endl;
  }
  virtual void buildFoulPushRPMode() {
    cout << "ParserIntfc::buildFoulPushRPMode(): called" << endl;
  }
  virtual void buildFoulMultipleAttackLPMode() {
    cout << "ParserIntfc::buildFoulMultipleAttackLPMode(): called" << endl;
  }
  virtual void buildFoulMultipleAttackRPMode() {
    cout << "ParserIntfc::buildFoulMultipleAttackRPMode(): called" << endl;
  }
  virtual void buildFoulBallOutLPMode() {
    cout << "ParserIntfc::buildFoulBallOutLPMode(): called" << endl;
  }
  virtual void buildFoulBallOutRPMode() {
    cout << "ParserIntfc::buildFoulBallOutRPMode(): called" << endl;
  }
  virtual void buildBackPassLPMode() {
    cout << "ParserIntfc::buildBackPassLPMode(): called" << endl;
  }
  virtual void buildBackPassRPMode() {
    cout << "ParserIntfc::buildBackPassRPMode(): called" << endl;
  }
  virtual void buildFreeKickFaultLPMode() {
    cout << "ParserIntfc::buildFreeKickFaultLPMode(): called" << endl;
  }
  virtual void buildFreeKickFaultRPMode() {
    cout << "ParserIntfc::buildFreeKickFaultRPMode(): called" << endl;
  }
  virtual void buildGoalieCatchBallLPMode() {
    cout << "ParserIntfc::buildGoalieCatchBallLPMode(): called" << endl;
  }
  virtual void buildGoalieCatchBallRPMode() {
    cout << "ParserIntfc::buildGoalieCatchBallRPMode(): called" << endl;
  }
  virtual void buildHalfTimePMode() {
    cout << "ParserIntfc::buildHalfTimePMode(): called" << endl;
  }
  virtual void buildTimeUpRPMode() {
    cout << "ParserIntfc::buildTimeUpRPMode(): called" << endl;
  }
  virtual void buildIndirectFreeKickLPMode() {
    cout << "ParserIntfc::buildIndirectFreeKickLPMode(): called" << endl;
  }
  virtual void buildIndirectFreeKickRPMode() {
    cout << "ParserIntfc::buildIndirectFreeKickRPMode(): called" << endl;
  }
  virtual void buildPenaltySetupLPMode() {
    cout << "ParserIntfc::buildPenaltySetupLPMode(): called" << endl;
  }
  virtual void buildPenaltySetupRPMode() {
    cout << "ParserIntfc::buildPenaltySetupRPMode(): called" << endl;
  }
  virtual void buildPenaltyReadyLPMode() {
    cout << "ParserIntfc::buildPenaltyReadyLPMode(): called" << endl;
  }
  virtual void buildPenaltyReadyRPMode() {
    cout << "ParserIntfc::buildPenaltyReadyRPMode(): called" << endl;
  }
  virtual void buildPenaltyTakenLPMode() {
    cout << "ParserIntfc::buildPenaltyTakenLPMode(): called" << endl;
  }
  virtual void buildPenaltyTakenRPMode() {
    cout << "ParserIntfc::buildPenaltyTakenRPMode(): called" << endl;
  }
  virtual void buildPenaltyMissLPMode() {
    cout << "ParserIntfc::buildPenaltyMissLPMode(): called" << endl;
  }
  virtual void buildPenaltyMissRPMode() {
    cout << "ParserIntfc::buildPenaltyMissRPMode(): called" << endl;
  }
  virtual void buildPenaltyScoreLPMode() {
    cout << "ParserIntfc::buildPenaltyScoreLPMode(): called" << endl;
  }
  virtual void buildPenaltyScoreRPMode() {
    cout << "ParserIntfc::buildPenaltyScoreRPMode(): called" << endl;
  }
  virtual void buildPenaltySideR() {
    cout << "ParserIntfc::buildPenaltySideR(): called" << endl;
  }
  virtual void buildPenaltySideL() {
    cout << "ParserIntfc::buildPenaltySideR(): called" << endl;
  }

  virtual void buildSenseBody(int time, float stamina, float effort,
			      float speedAmount, float speedDir,
			      float headAngle, int kickCount, int dashCount,
			      int turnCount, int sayCount, int turnNeckCount,
			      int catchCount, int moveCount,
			      int changeViewCount) {
    cout << "ParserIntfc::buildSenseBody("
	 << time << ", " << stamina << ", " << effort << ", " 
	 << speedAmount << ", " << speedDir << ", " 
	 << headAngle << ", " << kickCount << dashCount << ", " 
	 << turnCount << ", " << sayCount << turnNeckCount << ", " 
	 << catchCount << ", " << moveCount << ", " 
	 << changeViewCount
	 << "): called" << endl;
  }

  virtual void buildArmInfo(int movable, int expires, float targetDist,
			    float targetDir, int count) {
    cout << "ParserIntfc::buildArmInfo("
	 << movable << ", " << expires << ", " << targetDist << ", "
	 << targetDir << ", " << count
	 << "): called" << endl;
  }

  virtual void buildFocusInfo(int count) {
    cout << "ParserIntfc::buildFocusInfo(" << count << "): called" << endl;
  }
  virtual void buildFocusTargetNone() {
    cout << "ParserIntfc::buildFocusTargetNone(): called" << endl;
  }
  virtual void buildFocusTarget(int unum) {
    cout << "ParserIntfc::buildFocusTarget(" << unum << "): called" << endl;
  }
  virtual void buildTackleInfo(int expires, int count) {
    cout << "ParserIntfc::buildTackleInfo(" << expires << ", " << count
	 << "): called" << endl;
  }

  virtual void buildViewQualityHigh() {
    cout << "ParserIntfc::buildViewQualityHigh(): called" << endl;
  }
  virtual void buildViewQualityLow() {
    cout << "ParserIntfc::buildViewQualityLow(): called" << endl;
  }

  virtual void buildViewWidthNarrow() {
    cout << "ParserIntfc::buildViewWidthNarrow(): called" << endl;
  }
  virtual void buildViewWidthNormal() {
    cout << "ParserIntfc::buildViewWidthNormal(): called" << endl;
  }
  virtual void buildViewWidthWide() {
    cout << "ParserIntfc::buildViewWidthWide(): called" << endl;
  }

  virtual void buildScore( int time, int our, int their) {
    cout << "ParserIntfc::buildScore(" << time << ", " << our << ", "
	 << their << "): called" << endl;
  }

  virtual void buildSubstitution( int unum, int type ) {
    cout << "ParserIntfc::buildSubstitution(" << unum << ", " << type
	 << "): called" << endl;
  }
  virtual void buildSubstitution( int unum ) {
    cout << "ParserIntfc::buildSubstitution(" << unum << "): called" << endl;
  }

  virtual void buildCantReconnect() {
    cout << "ParserIntfc::buildCantReconnect(): called" << endl;
  }
  virtual void buildInitError() {
    cout << "ParserIntfc::buildInitError(): called" << endl;
  }
  virtual void buildNoMoreTeamOrPlayerOrGoalieError() {
    cout << "ParserIntfc::buildNoMoreTeamOrPlayerOrGoalieError(): called" << endl;
  }
  virtual void buildNoSuchTeamOrAlreadyHaveCoachError() {
    cout << "ParserIntfc::buildNoSuchTeamOrAlreadyHaveCoachError(): called" << endl;
  }
  virtual void buildTooManyMovesError() {
    cout << "ParserIntfc::buildTooManyMovesError(): called" << endl;
  }
  virtual void buildUnknownCommandError() {
    cout << "ParserIntfc::buildUnknownCommandError(): called" << endl;
  }
  virtual void buildIllegalCommandError() {
    cout << "ParserIntfc::buildIllegalCommandError(): called" << endl;
  }
  virtual void buildSayMessageTooLongError() {
    cout << "ParserIntfc::buildSayMessageTooLongError(): called" << endl;
  }
  virtual void buildIllegalModeError() {
    cout << "ParserIntfc::buildIllegalModeError(): called" << endl;
  }
  virtual void buildIllegalObjectFormError() {
    cout << "ParserIntfc::buildIllegalObjectFormError(): called" << endl;
  }
  virtual void buildSaidTooManyFreeformMessagesError() {
    cout << "ParserIntfc::buildSaidTooManyFreeformMessagesError(): called" << endl;
  }
  virtual void buildCannotSayFreeformWhilePlayonError() {
    cout << "ParserIntfc::buildCannotSayFreeformWhilePlayonError(): called" << endl;
  }
  virtual void buildSaidTooManyMetaMessagesError() {
    cout << "ParserIntfc::buildSaidTooManyMetaMessagesError(): called" << endl;
  }
  virtual void buildSaidTooManyAdviceMessagesError() {
    cout << "ParserIntfc::buildSaidTooManyAdviceMessagesError(): called" << endl;
  }
  virtual void buildSaidTooManyInfoMessagesError() {
    cout << "ParserIntfc::buildSaidTooManyInfoMessagesError(): called" << endl;
  }
  virtual void buildSaidTooManyDefineMessagesError() {
    cout << "ParserIntfc::buildSaidTooManyDefineMessagesError(): called" << endl;
  }
  virtual void buildCouldNotParseSayError() {
    cout << "ParserIntfc::buildCouldNotParseSayError(): called" << endl;
  }
  virtual void buildSaidTooManyMessagesError() {
    cout << "ParserIntfc::buildSaidTooManyMessagesError(): called" << endl;
  }
  virtual void buildUnknownError( const char *error ) {
    cout << "ParserIntfc::buildUnknownError(" << error << "): called" << endl;
  }

  virtual void buildNoTeamFoundWarning() {
    cout << "ParserIntfc::buildNoTeamFoundWarning(): called" << endl;
  }
  virtual void buildNoSuchPlayerWarning() {
    cout << "ParserIntfc::buildNoSuchPlayerWarning(): called" << endl;
  }
  virtual void buildCannotSubWhilePlayOnWarning() {
    cout << "ParserIntfc::buildCannotSubWhilePlayOnWarning(): called" << endl;
  }
  virtual void buildNoSubsLeftWarning() {
    cout << "ParserIntfc::buildNoSubsLeftWarning(): called" << endl;
  }
  virtual void buildMaxOfThatPlayerTypeOnFieldWarning() {
    cout << "ParserIntfc::buildMaxOfThatPlayerTypeOnFieldWarning(): called" << endl;
  }
  virtual void buildCannotChangeGoalieWarning() {
    cout << "ParserIntfc::buildCannotChangeGoalieWarning(): called" << endl;
  }
  virtual void buildUnknownWarning( const char *warning ) {
    cout << "ParserIntfc::buildUnknownWarning(" << warning << "): called" << endl;
  }

  virtual void buildClangVerOK( int min, int max ) {
    cout << "ParserIntfc::buildClangVerOK(" << min << ", " << max << "): called" << endl;
  }
  virtual void buildEyeOK( bool eyeOn ) {
    cout << "ParserIntfc::buildEyeOK(" << eyeOn << "): called" << endl;
  }
  virtual void buildUnknownOK( const char *ok ) {
    cout << "ParserIntfc::buildUnknownOK(" << ok << "): called" << endl;
  }

  virtual void buildCoachAudio( int time, const char *msg ) {
    cout << "ParserIntfc::buildCoachAudio(" << time << ", " << msg << "): called" << endl;
  }
  virtual void buildNeutralSide() {
    cout << "ParserIntfc::buildNeutralSide(): called" << endl;
  }

  virtual void buildRefAudio( int time ) {
    cout << "ParserIntfc::buildRefAudio(" << time << "): called" << endl;
  }
  virtual void buildGoalRefAudio( int time, int goals ) {
    cout << "ParserIntfc::buildGoalRefAudio(" << time << ", " << goals << "): called" << endl;
  }
  virtual void buildUnknownRefAudio( int time, const char *msg ) {
    cout << "ParserIntfc::buildUnknownRefAudio(" << time << ", " << msg << "): called" << endl;
  }

  virtual void buildPlayerAudio( int time, float dir, int unum,
				 const char *msg ) {
    cout << "ParserIntfc::buildPlayerAudio("
	 << time << ", " << dir << ", " << unum << ", " << msg
	 << "): called" << endl;
  }
  virtual void buildPlayerAudio( int time, float dir, const char *msg ) {
    cout << "ParserIntfc::buildPlayerAudio("
	 << time << ", " << dir << ", " << ", " << msg
	 << "): called" << endl;
  }
  virtual void buildPlayerAudio( int time, int unum ) {
    cout << "ParserIntfc::buildPlayerAudio(" << time << ", " << unum << "): called" << endl;
  }
  virtual void buildPlayerAudio( int time ) {
    cout << "ParserIntfc::buildPlayerAudio(" << time << "): called" << endl;
  }


  virtual void buildSelfAudio( int time, const char *msg ) {
    cout << "ParserIntfc::buildSelfAudio(" << time << ", " << msg << "): called" << endl;
  }

  virtual void buildFullState( int time ) {
    cout << "ParserIntfc::buildFullState(" << time << "): called" << endl;
  }
  virtual void buildFsCount(
    int kickCount,
    int dashCount,
    int turnCount,
    int sayCount,
    int turnNeckCount,
    int catchCount,
    int moveCount,
    int changeViewCount
    ) {
    cout << "ParserIntfc::buildFsCount("
	 << kickCount << ", "
	 << dashCount << ", "
	 << turnCount << ", "
	 << sayCount << ", "
	 << turnNeckCount << ", "
	 << catchCount << ", "
	 << moveCount << ", "
	 << changeViewCount
	 << "): called" << endl;
  }

  virtual void buildFsScore( int our, int their) {
    cout << "ParserIntfc::buildFsScore(" << our << ", " << their << "): called" << endl;
  }

  virtual void buildFsBall( float posx, float posy, float velx,
			    float vely ) {
    cout << "ParserIntfc::buildFsBall(" << posx << ", " << posy << ", " << velx << ", "
	 << vely << "): called" << endl;
  }
  virtual void buildFsPlayer(float posx, float posy, float velx, float vely,
			     float bodyDir, float faceDir) {
    cout << "ParserIntfc::buildFsPlayer(" << posx << ", " << posy << ", " << velx << ", "
	 << vely << ", " << bodyDir << ", " << faceDir << "): called" << endl;
  }

  virtual void buildFsPlayername( int unum ) {
    cout << "ParserIntfc::buildFsPlayername(" << unum << "): called" << endl;
  }
  virtual void buildFsPlayerType( bool goalie ) {
    cout << "ParserIntfc::buildFsPlayerType(" << goalie << "): called" << endl;
  }
  virtual void buildFsPlayerType( int type ) {
    cout << "ParserIntfc::buildFsPlayerType(" << type << "): called" << endl;
  }
  virtual void buildFsStaminaInfo( float stamina, float effort, float recovery ) {
    cout << "ParserIntfc::buildFsStaminaInfo(" << stamina << ", " << effort << ", "
	 << recovery << "): called" << endl;
  }


  //visual related
  virtual void buildVisual( int time ) {
    cout << "ParserIntfc::buildVisual(" << time << "): called" << endl;
  }
  virtual void buildGlobalVisual( int time ) {
    cout << "ParserIntfc::buildGlobalVisual(" << time << "): called" << endl;
  }

  virtual void buildLine( float dir ) {
    cout << "ParserIntfc::buildLine(" << dir << "): called" << endl;
  }
  virtual void buildLine( float dist, float dir ) {
    cout << "ParserIntfc::buildLine(" << dist << ", " << dir
	 << "): called" << endl;
  }

  virtual void buildFlag( bool close, float dist, float dir, float distChg,
			  float dirChg ) {
    cout << "ParserIntfc::buildFlag(" << close << ", " << dist << ", "
	 << dir << ", " << distChg << ", " << dirChg
	 << "): called" << endl;
  }
  virtual void buildFlag( bool close, float dist, float dir ) {
    cout << "ParserIntfc::buildFlag(" << close << ", " << dist << ", " << dir 
	 << "): called" << endl;
  }
  virtual void buildFlag( bool close, float dir ) {
    cout << "ParserIntfc::buildFlag(" << close << ", " << dir 
	 << "): called" << endl;
  }

  virtual void buildGoal( bool close, float dist, float dir, float distChg,
			  float dirChg ) {
    cout << "ParserIntfc::buildGoal(" << close << ", " << dist << ", "
	 << dir << ", " << distChg << ", " << dirChg
	 << "): called" << endl;
  }
  virtual void buildGoal( bool close, float dist, float dir ) {
    cout << "ParserIntfc::buildGoal(" << close << ", " << dist << ", " << dir 
	 << "): called" << endl;
  }
  virtual void buildGoal( bool close, float dir ) {
    cout << "ParserIntfc::buildGoal(" << close << ", " << dir 
	 << "): called" << endl;
  }

  virtual void buildGlobalGoal( float posx, float posy ) {
    cout << "ParserIntfc::buildGlobalGoal(" << posx << ", " << posy 
	 << "): called" << endl;
  }

  virtual void buildBall( bool close, float dist, float dir, float distChg,
			  float dirChg ) {
    cout << "ParserIntfc::buildBall(" << close << ", " << dist << ", "
	 << dir << ", " << distChg << ", " << dirChg
	 << "): called" << endl;
  }
  virtual void buildBall( bool close, float dist, float dir ) {
    cout << "ParserIntfc::buildBall(" << close << ", " << dist << ", " << dir 
	 << "): called" << endl;
  }
  virtual void buildBall( bool close, float dir ) {
    cout << "ParserIntfc::buildBall(" << close << ", " << dir 
	 << "): called" << endl;
  }

  virtual void buildGlobalBall( float posx, float posy, float velx, float vely ) {
    cout << "ParserIntfc::buildGlobalGoal(" << posx << ", " << posy 
	 << ", " << velx << ", " << vely << "): called" << endl;
  }

  virtual void buildPlayer( bool close, float dist, float dir, float distChg,
			    float dirChg, float bodyDir, float faceDir ) {
    cout << "ParserIntfc::buildPlayer(" << close << ", " << dist << ", "
	 << dir << ", " << distChg << ", " << dirChg << ", " << bodyDir << ", "
	 << faceDir << "): called" << endl;
  }
  virtual void buildPlayer( bool close, float dist, float dir, float distChg,
			    float dirChg ) {
    cout << "ParserIntfc::buildPlayer(" << close << ", " << dist << ", "
	 << dir << ", " << distChg << ", " << dirChg << "): called" << endl;
  }
  virtual void buildPlayer( bool close, float dist, float dir ) {
    cout << "ParserIntfc::buildPlayer(" << close << ", " << dist << ", "
	 << dir << "): called" << endl;
  }
  virtual void buildPlayer( bool close, float dir) {
    cout << "ParserIntfc::buildPlayer(" << close << ", " << dir
	 << "): called" << endl;
  }

  virtual void buildPlayerExtraInfo( bool tackling ) {
    cout << "ParserIntfc::buildPlayerExtraInfo(" << tackling
	 << "): called" << endl;
  }
  virtual void buildPlayerExtraInfo( float pointdir ) {
    cout << "ParserIntfc::buildPlayerExtraInfo(" << pointdir
	 << "): called" << endl;
  }
  virtual void buildPlayerExtraInfo( float pointdir, bool tackling ) {
    cout << "ParserIntfc::buildPlayerExtraInfo(" << pointdir << ", " 
	 << tackling << "): called" << endl;
  }


  virtual void buildGlobalPlayer( float posx, float posy, float velx,
				  float vely, float bodyDir,
				  float faceDir) {
    cout << "ParserIntfc::buildGlobalGoal(" << posx << ", " << posy 
	 << ", " << velx << ", " << vely << ", " << bodyDir << ", "
	 << faceDir << "): called" << endl;
  }

  virtual void buildPlayerName() {
    cout << "ParserIntfc::buildPlayerName(): called" << endl;
  }
  virtual void buildPlayerName( const char *teamname ) {
    cout << "ParserIntfc::buildPlayerName(" << teamname << "): called" << endl;
  }
  virtual void buildPlayerName( const char *teamname, int unum ) {
    cout << "ParserIntfc::buildPlayerName(" << teamname << ", " << unum
	 << "): called" << endl;
  }
  virtual void buildPlayerName( const char *teamname, int unum,
				bool goalie ) {
    cout << "ParserIntfc::buildPlayerName(" << teamname << ", " << unum
	 << ", " << goalie << "): called" << endl;
  }

  virtual void buildFlagOffset( int offset ) {
    cout << "ParserIntfc::buildFlagOffset(" << offset << "): called" << endl;
  }

  virtual void buildTopLocation()    {
    cout << "ParserIntfc::buildTopLocation(): called" << endl;
  }
  virtual void buildBottomLocation() {
    cout << "ParserIntfc::buildBottomLocation(): called" << endl;
  }
  virtual void buildLeftLocation()   {
    cout << "ParserIntfc::buildLeftLocation(): called" << endl;
  }
  virtual void buildRightLocation()  {
    cout << "ParserIntfc::buildRightLocation(): called" << endl;
  }
  virtual void buildCenterLocation() {
    cout << "ParserIntfc::buildCenterLocation(): called" << endl;
  }
  virtual void buildPenaltyLocation(){
    cout << "ParserIntfc::buildPenaltyLocation(): called" << endl;
  }
  virtual void buildGoalLocation()   {
    cout << "ParserIntfc::buildGoalLocation(): called" << endl;
  }

  virtual void buildThink() {
    cout << "ParserIntfc::buildThink(): called" << endl;
  }
  virtual void buildPlayerTypeDetection(){
    cout << "ParserIntfc::buildPlayerTypeDetection(): called" << endl;
  }
  virtual void buildPlayerTypeDetected(const char *msg){
    cout << "  received: " << msg << endl;
  }

    virtual void buildCoachFreeform(const char *msg){
	cout << "  received: " << msg << endl;
    }

};


static void usage()
{
  cout << "Usage: player_lang_test <file containing server messages>\n\n"
    "This program tests the parser used in the robocup scenario to parse the "
    "incoming soccer server messages"
    <<  endl;
}


int main(int argc, char *argv[])
{
  // Check command line 
  if (argc != 2){
    usage();
    return 1;
  }

  char buf[4096];
  ifstream *file = new ifstream(argv[1]);

  TestParser parser = TestParser();
  while(file->good()){
    file->getline(buf, 4096, '\n');
    parser.parse(buf);
  }
}

