#ifndef __WING_ATTACKER_BEHAVIOUR_H
#define __WING_ATTACKER_BEHAVIOUR_H

#include "Agent.hh"
#include "Geometry.hh"

class WingAttackerBehaviour : public Behaviour
{
public:

  /** Constructor initializing the Behaviour and calling the super Constructor
      @param left is this the left Wing Attacker or the right Wing Attacker
  */
  WingAttackerBehaviour(bool left=true);

  /** Destructor doing nothing at the Moment, but this will change*/
  virtual ~WingAttackerBehaviour();

  /** Returns the Position to which the Wing Attacker should go if nearing thze Midfielder.
      @param the currently calculated Positio, if nearing is needed the position will be changed otherwise
      it will be left untouched
  */
  virtual void shouldNearMidfielderPosition(Vector2D* position);

  /** Handles the Behaviour if the Agent has the Ball (the Ball is kickable)*/
  void playOnWithBall();

private:

  /**Determines whether this is the left wing attacker*/
  bool leftWing;

};

#endif
